SystemOrganization addCategory: 'JASVGI-Seaside'!

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:47'!
drawHourCalendar: calendar at: aPoint width: width color: color dayHasContent: aBoolean
	"The receiver draw a vertical working day graph from <startDate> to <endDate> where <workingDays> dictionary key's is the day number and value is the color intensity.
	The width of each rectangle day is <width> and color is <color>"
	| currentPosition  hourColor |

	self svgGroup transform: ( 'translate(', aPoint x printString, ',', aPoint y printString, ')'); with: [

		currentPosition := aPoint.

		0 to: 11 do: [:hourIndex | | value rectHour currentTime |
			currentTime := Time fromString: hourIndex printString ,':00'.
			hourColor := (calendar timeIntervalExistFrom: currentTime to: (currentTime addSeconds: (60*60) - 1)) ifTrue: ['brown'] ifFalse: ['green'].
			rectHour := self drawRoundRectangleAt: currentPosition width: width height: width rx: 5 ry: 5 strokeWidth: '1px' stroke: 'red' fillColor: hourColor opacity: '1'.
			(aBoolean and: [value ~= 0]) 
			ifTrue: [self drawLinkText: currentTime printString callback: [] at: ((currentPosition x + 5) @ (currentPosition y + 12)) textSizePx: '10px' color: 'white']. 
			"draw the named of the days"
			currentPosition := (currentPosition x + width + 15) @ currentPosition y
		].

		currentPosition := aPoint x @ (currentPosition y + 100).
		12 to: 23 do: [:hourIndex | | value rectHour currentTime |
			currentTime := Time fromString: hourIndex printString ,':00'.
			hourColor := (calendar timeIntervalExistFrom: currentTime to: (currentTime addSeconds: (60*60) - 1)) ifTrue: ['brown'] ifFalse: ['green'].
			rectHour := self drawRoundRectangleAt: currentPosition width: width height: width rx: 5 ry: 5 strokeWidth: '1px' stroke: 'red' fillColor: hourColor opacity: '1'.
			(aBoolean and: [value ~= 0]) 
			ifTrue: [self drawLinkText: currentTime printString callback: [] at: ((currentPosition x + 5) @ (currentPosition y + 12)) textSizePx: '10px' color: 'white']. 
			"draw the named of the days"
			currentPosition := (currentPosition x + width + 15) @ currentPosition y
		].
	].! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:54'!
drawHourCalendar: calendar at: aPoint width: width color: color dayHasContent: aBoolean parent: sewafWebComposite actionMethod: actionMethod
	"The receiver draw a vertical working day graph from <startDate> to <endDate> where <workingDays> dictionary key's is the day number and value is the color intensity.
	The width of each rectangle day is <width> and color is <color>"
	| currentPosition  hourColor |

	self svgGroup transform: ( 'translate(', aPoint x printString, ',', aPoint y printString, ')'); with: [

		currentPosition := aPoint.

		0 to: 11 do: [:hourIndex | | value rectHour currentTime |
			currentTime := Time fromString: hourIndex printString ,':00'.
			hourColor := (calendar timeIntervalExistFrom: currentTime to: (currentTime addSeconds: (60*60) - 1)) ifTrue: ['brown'] ifFalse: ['green'].
			rectHour := self drawRoundRectangleAt: currentPosition width: width height: width rx: 5 ry: 5 strokeWidth: '1px' stroke: 'red' fillColor: hourColor opacity: '1'.
			(aBoolean and: [value ~= 0]) 
			ifTrue: [self drawLinkText: currentTime printString callback: [sewafWebComposite perform: actionMethod with: currentTime] at: ((currentPosition x + 5) @ (currentPosition y + 12)) textSizePx: '10px' color: 'white']. 
			"draw the named of the days"
			currentPosition := (currentPosition x + width + 15) @ currentPosition y
		].

		currentPosition := aPoint x @ (currentPosition y + 100).
		12 to: 23 do: [:hourIndex | | value rectHour currentTime |
			currentTime := Time fromString: hourIndex printString ,':00'.
			hourColor := (calendar timeIntervalExistFrom: currentTime to: (currentTime addSeconds: (60*60) - 1)) ifTrue: ['brown'] ifFalse: ['green'].
			rectHour := self drawRoundRectangleAt: currentPosition width: width height: width rx: 5 ry: 5 strokeWidth: '1px' stroke: 'red' fillColor: hourColor opacity: '1'.
			(aBoolean and: [value ~= 0]) 
			ifTrue: [self drawLinkText: currentTime printString callback: [sewafWebComposite perform: actionMethod with: currentTime] at: ((currentPosition x + 5) @ (currentPosition y + 12)) textSizePx: '10px' color: 'white']. 
			"draw the named of the days"
			currentPosition := (currentPosition x + width + 15) @ currentPosition y
		].
	].! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:45'!
drawLinkText: aString callback: aBlock at: aPoint id: id textSizePx: textSizePx color: color
	"The receiver draw the string <aString> at <aPoint> with id <id> and text size <textSizePx> "

	self anchor 
		callback: aBlock;
		with: [
			self svgText
				attributeAt: 'id' put: id;
				attributeAt: 'x' put: aPoint x;
				attributeAt: 'y' put: aPoint y;
				attributeAt: 'font-size' put: textSizePx;
				attributeAt: 'font-family' put: 'Tahoma';
				attributeAt: 'fill' put: color;
				with: aString.
			].! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:47'!
drawLinkText: aString callback: aBlock at: aPoint textSizePx: textSizePx color: color
	"The receiver draw the string <aString> at <aPoint> with id <id> and text size <textSizePx> "

	^self drawLinkText: aString callback: aBlock at: aPoint id: UUID new asString textSizePx: textSizePx color: color! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:37'!
drawRoundRectangleAt: aPoint id: id width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor
	"The receiver draw a round rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRoundRectangleAt: aPoint id: id width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor opacity: '1'! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:38'!
drawRoundRectangleAt: aPoint id: id width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor opacity: opacity
	"The receiver draw a round rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	self svgRectangle
		attributeAt: 'id' put: id;
		attributeAt: 'x' put: aPoint x;
		attributeAt: 'y' put: aPoint y;
		attributeAt: 'rx' put: rx;
		attributeAt: 'ry' put: ry;
		attributeAt: 'fill' put: fillColor;
		attributeAt: 'height' put: height;
		attributeAt: 'width' put: width;
		attributeAt: 'stroke' put: stroke;
		attributeAt: 'stroke-width' put: widthPx;
		attributeAt: 'opacity' put: opacity! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:37'!
drawRoundRectangleAt: aPoint width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor
	"The receiver draw a round rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRoundRectangleAt: aPoint id: UUID new asString width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:39'!
drawRoundRectangleAt: aPoint width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor opacity: opacity
	"The receiver draw a round rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRoundRectangleAt: aPoint id: UUID new asString width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor opacity: opacity! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:43'!
drawText: aString at: aPoint id: id textSizePx: textSizePx color: color
	"The receiver draw the string <aString> at <aPoint> with id <id> and text size <textSizePx> "

	self svgText
		attributeAt: 'id' put: id;
		attributeAt: 'x' put: aPoint x;
		attributeAt: 'y' put: aPoint y;
		attributeAt: 'font-size' put: textSizePx;
		attributeAt: 'font-family' put: 'Tahoma';
		attributeAt: 'fill' put: color;
		with: aString.! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/15/2017 12:43'!
drawText: aString at: aPoint textSizePx: textSizePx color: color
	"The receiver draw the string <aString> at <aPoint> with id <id> and text size <textSizePx> "

	^self drawText: aString at: aPoint id: UUID new asString textSizePx: textSizePx color: color! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:29'!
svgCanvas

	^self brush: WASvgCanvasTag new! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:22'!
svgCanvas: aBlock

	self svgCanvas with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:32'!
svgCircle

	^self brush: WASvgCircleTag new! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:33'!
svgCircle: aBlock

	self svgCircle with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:43'!
svgConnector

	^self brush: WASvgConnectorTag new! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:52'!
svgConnector: aBlock

	self svgConnector with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:47'!
svgGroup

	^self brush: WASvgGroupTag new! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:52'!
svgGroup: aBlock

	self svgGroup with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:35'!
svgLine

	^self tag: 'line'! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:36'!
svgLine: aBlock

	self svgLine with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:51'!
svgMarker

	^self brush: WASvgMarkerTag new! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:52'!
svgMarker: aBlock

	self svgMarker with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:55'!
svgPath

	^self brush: WASvgPathTag new! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:55'!
svgPath: aBlock

	self svgPath with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:37'!
svgPoint

	^self tag: 'point'! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:36'!
svgPoint: aBlock

	self svgPoint with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:38'!
svgRectangle

	^self brush: WASvgRectangleTag new! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:38'!
svgRectangle: aBlock

	^self svgRectangle with: aBlock! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:58'!
svgText

	^self tag: 'text'! !

!WAHtmlCanvas methodsFor: '*JASVGI-Seaside' stamp: 'BrunoBB 02/14/2017 12:58'!
svgText: aBlock

	^self svgText with: aBlock! !

WATagBrush subclass: #WASvgBasicFigureTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgBasicFigureTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:42'!
tag

	self subclassResponsibility! !

WASvgBasicFigureTag subclass: #WASvgCircleTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgCircleTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:32'!
tag

	^'circle'! !

WASvgBasicFigureTag subclass: #WASvgEllipseTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgEllipseTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:34'!
tag

	^'ellipse'! !

WASvgBasicFigureTag subclass: #WASvgPathTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgPathTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:55'!
tag

	^'path'! !

WASvgBasicFigureTag subclass: #WASvgRectangleTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgRectangleTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:38'!
tag

	^'rect'! !

WATagBrush subclass: #WASvgCanvasTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgCanvasTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:47'!
tag
	^ 'svg'! !

WATagBrush subclass: #WASvgConnectorTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgConnectorTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:47'!
tag
	^ 'connector'! !

WATagBrush subclass: #WASvgGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgGroupTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:47'!
tag

	^'g'! !

!WASvgGroupTag methodsFor: 'other' stamp: 'BrunoBB 02/15/2017 09:53'!
transform: transformationString

	self attributeAt: 'transform' put: transformationString! !

WATagBrush subclass: #WASvgMarkerTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Seaside'!

!WASvgMarkerTag methodsFor: 'other' stamp: 'BrunoBB 02/14/2017 12:51'!
tag

	^'marker'! !
